//+------------------------------------------------------------------+
//|                                                  _Stochastic.mq4 |
//|                                          Copyright 2012,  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, "
#property link      ""

extern double StopLoss   =200;     // SL   
extern double TakeProfit =39;      //    
extern double Lots       =0.01;     //   . 
extern int ModeMain = 5;
extern int ModeSignal = 3;
extern int Slowing = 3;
extern double    OpenSlippage=3.0;
extern double    CloseSlippage=30.0;

int i,CurrentTrade;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   double M_0, M_1,               //  MAIN  0  1 
   S_0, S_1;               //  SIGNAL  0  1
//--------------------------------------------------------------------
   //    ..
   M_0=iStochastic(NULL,0,ModeMain,ModeSignal,Slowing,MODE_SMA,0,MODE_MAIN,  0);// 0 
   M_1=iStochastic(NULL,0,ModeMain,ModeSignal,Slowing,MODE_SMA,0,MODE_MAIN,  1);// 1 
   S_0=iStochastic(NULL,0,ModeMain,ModeSignal,Slowing,MODE_SMA,0,MODE_SIGNAL,0);// 0 
   S_1=iStochastic(NULL,0,ModeMain,ModeSignal,Slowing,MODE_SMA,0,MODE_SIGNAL,1);// 1 
//--------------------------------------------------------------------
   //  
   if(M_1 < S_1 && M_0>=S_0) //     // Alert("  . ."); //  
      {                       //if there's already a trade open, check it
      CurrentTrade=0;
      if(OrdersTotal()>0)     //see if there are any open contracts  
         {
         for(i=OrdersTotal()-1;i>=0;i--)
            {
            OrderSelect(i,SELECT_BY_POS,MODE_TRADES);       //if it's a Sell close it
            if(OrderType()==OP_SELL && OrderSymbol()==Symbol())
               OrderClose(OrderTicket(),OrderLots(),Ask,CloseSlippage,Red);
            if(OrderType()==OP_BUY && OrderSymbol()==Symbol())
               CurrentTrade=1;
            }
         }
       if(CurrentTrade==0)                                  //if theres no trades open one up
         OrderSend(Symbol(),OP_BUY,Lots,Ask,OpenSlippage,Bid-StopLoss*Point,Bid+TakeProfit*Point,"",0,0,Green);
       return(0);
      }
   if(M_1 > S_1 && M_0<=S_0) //     // Alert("  . ."); //  
      {
      CurrentTrade=0;
      if(OrdersTotal()>0)
         {
         for(i=OrdersTotal()-1;i>=0;i--)                  //see if there are any open contracts 
            {
            OrderSelect(i,SELECT_BY_POS,MODE_TRADES);    //if it's a Buy close it
            if(OrderType()==OP_BUY && OrderSymbol()==Symbol())
               OrderClose(OrderTicket(),OrderLots(),Bid,CloseSlippage,Red);
            if(OrderType()==OP_SELL && OrderSymbol()==Symbol())
               CurrentTrade=1;
            }
         }
       if(CurrentTrade==0)                            //if theres no trades open one up
         OrderSend(Symbol(),OP_SELL,Lots,Bid,OpenSlippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",0,0,Green);
       return(0);
      }
  }
  

